<?php

function bookmark_add($zid, $uid)
{
  $query = sprintf("INSERT INTO bookmarks (uid,zeitung) VALUES (%d,%d)",
		   $uid, $zid);

  # Ignore potentially existing bookmark
  db_query($query);
}

function bookmark_delete($zid, $uid)
{
  $query = sprintf("DELETE FROM bookmarks " .
		   "WHERE uid = %d AND zeitung = %d",
		   $uid, $zid);

  # Ignore potentially non-existing bookmark
  db_query($query);
}

function bookmark_up($zid, $uid)
{
  $query = sprintf("UPDATE bookmarks SET priority = priority - 1 " .
		   "WHERE uid = %d AND zeitung = %d",
		   $uid, $zid);

  # Ignore potentially non-existing bookmark
  db_query($query);
}

function bookmark_down($zid, $uid)
{
  $query = sprintf("UPDATE bookmarks SET priority = priority + 1 " .
		   "WHERE uid = %d AND zeitung = %d",
		   $uid, $zid);

  # Ignore potentially non-existing bookmark
  db_query($query);
}

function format_bookmarks()
{
  global $_SESSION;

  if (!isset($_SESSION['uid']))
    return;

  $query = sprintf("SELECT zeitung,name,priority FROM bookmarks " .
		   "JOIN zeitungen ON zeitungen.id = zeitung " .
		   "WHERE uid = %d " .
		   "ORDER BY priority,name LIMIT 20",
		   $_SESSION['uid']);

  $sth = db_query($query);

  if ($sth === false || pg_NumRows ($sth) == 0)
    return '&nbsp;';

$rowf = '<tr>
<td width="85">
<a %s><img src="up.png" width="16" height="16" alt="up" title="Nach oben schieben" border="0"></a>
<strong>%d</strong>
<a %s><img src="down.png" width="16" height="16" alt="up" title="Nach unten schieben" border="0"></a>
<a %s><img src="delete.gif" width="16" height="16" alt="delete" title="Lesezeichen löschen" border="0"></a>
</td>
<td>
<a href="zeitung/%d.html">%s</a></td>
</tr>';

  $ret .= '<table class="bookmarks" width="100%", alt=¨">';
  for ($n=0; $n < pg_NumRows ($sth); $n++) {
    $row = pg_fetch_array ($sth, $n);

    if (javascript_ok()) {
      $link_up = sprintf('href="bookmark.html" onclick="return bookmark_action(\'up\',%d);"', $row['zeitung']);
      $link_down = sprintf('href="bookmark.html" onclick="return bookmark_action(\'down\',%d);"', $row['zeitung']);
      $link_del = sprintf('href="bookmark.html" onclick="return bookmark_action(\'del\',%d);"', $row['zeitung']);
    } else {
      $link_up = sprintf('href="bookmark.html?zeitung=%d&action=up"', $row['zeitung']);
      $link_down = sprintf('href="bookmark.html?zeitung=%d&action=down"', $row['zeitung']);
      $link_del = sprintf('href="bookmark.html?zeitung=%d&action=delete"', $row['zeitung']);
    }

    $ret .= sprintf($rowf,
		    $link_up, $row['priority'], $link_down, $link_del,
		    $row['zeitung'], $row['name']);
  }
  $ret .= '</table>';


  return $ret;
}

function bookmarks_manage()
{
  global $_SESSION;

  if (!isset($_SESSION['uid']))
    return notfound();

  $ret = '<h3>Verwaltung der persönlichen Lesezeichen</h3>';

  $ret .= '<div id="bookmarks">';
  $ret .= load_javascript('bookmarks.js');
  $ret .= format_bookmarks();
  $ret .= '</div>';

  return $ret;
}

function process_bookmark()
{
  global $_SESSION;
  global $_SERVER;
  global $_GET;
  global $zlist;
  global $cfg;

  if (!isset($_SESSION['uid']))
    return notfound();

  if (empty($_SERVER['QUERY_STRING'])) {
    return bookmarks_manage();
  } elseif (!isset($_GET['zeitung']) || !is_numeric($_GET['zeitung'])) {
    if (isset($_SERVER['HTTP_REFERER']))
      $zlist['redirect'] = substr($_SERVER['HTTP_REFERER'], strlen($zlist['home']));
    return warning('Keine Zeitung oder Magazin gefunden.');
  } elseif (isset($_GET['action'])) {
    if ($_GET['action'] == 'up')
      bookmark_up($_GET['zeitung'], $_SESSION['uid']);
    elseif ($_GET['action'] == 'down')
      bookmark_down($_GET['zeitung'], $_SESSION['uid']);
    elseif ($_GET['action'] == 'delete')
      bookmark_delete($_GET['zeitung'], $_SESSION['uid']);
    else
      return notfound();
    header('Location: ' . $cfg['home'] . 'bookmark.html');
    exit;
  } else {
    bookmark_add($_GET['zeitung'], $_SESSION['uid']);
    if (isset($_SERVER['HTTP_REFERER'])) {
      header('Location: ' . $_SERVER['HTTP_REFERER']);
      exit;
    } else
      return information('Ihr Lesezeichen wurde hinzugefügt');
  }
}

function ajax_bookmark_check()
{
  global $_POST;
  global $_SESSION;

  if (!isset($_POST['zeitung']) || !is_numeric($_POST['zeitung']) ||
      !isset($_SESSION['uid']))
    return false;

  return true;
}

function ajax_bookmark_up()
{
  global $_POST;
  global $_SESSION;

  if (!ajax_bookmark_check())
    return false;

  bookmark_up($_POST['zeitung'], $_SESSION['uid']);

  return format_bookmarks();
}

function ajax_bookmark_down()
{
  global $_POST;
  global $_SESSION;

  if (!ajax_bookmark_check())
    return false;

  bookmark_down($_POST['zeitung'], $_SESSION['uid']);

  return format_bookmarks();
}

function ajax_bookmark_del()
{
  global $_POST;
  global $_SESSION;

  if (!ajax_bookmark_check())
    return false;

  bookmark_delete($_POST['zeitung'], $_SESSION['uid']);

  return format_bookmarks();
}

function ajax_bookmark_add()
{
  global $_POST;
  global $_SESSION;

  if (!ajax_bookmark_check())
    return false;

  bookmark_add($_POST['zeitung'], $_SESSION['uid']);

  return format_info_bookmarks();
}


?>